<template>
  <PageWrapper>
    <a-card :bordered="false" class="pt-3 mb-3 proCard">
      <BasicForm @register="register" @submit="handleSubmit" @reset="handleReset" />
    </a-card>
    <a-card :bordered="false" class="proCard">
      <a-table
        :columns="columns"
        :style="{ minHeight: fwbHeight + 'px' }"
        :scroll="{ x: '100%', y: fwbHeight + 'px' }"
        :pagination="{ hideOnSinglePage: true }"
        :dataSource="onlineTableData.slice((pager.page - 1) * pager.size, pager.page * pager.size)"
      >
        <template #bodyCell="{ column, record,index }">
          <template v-if="column.key === 'index'">
            {{index+1}}
          </template>
          <template v-if="column.key === 'action'">
            <a-space>
              <a-button type="danger" @click="handleDelete(record.tokenId)">
                <template #icon><EditOutlined /></template>
                强退
              </a-button>
            </a-space>
          </template>
        </template>
      </a-table>
      <pagination
        style="justify-content: flex-end"
        class="mt-10 flex"
        v-model="pager"
        @change="loadDataTable"
      />
    </a-card>
  </PageWrapper>
</template>

<script lang="ts" setup>
  import { reactive, ref, onMounted } from 'vue';
  import { columns } from './columns';
  import { schemas } from './querySchemas';
  import { useForm } from '@/components/Form/index';
  import { getOnlineList, onlineOut } from '@/api/monitor/online';
  import { Modal, message } from 'ant-design-vue';
  const onlineTableData = ref([]);

  /**
   * 定义查询参数
   */
  const formParams = reactive({
    ipAddr: '',
    username: '',
  });

  /**
   * 定义分页参数
   */
  const pager = ref({
    page: 1,
    size: 10,
    count: onlineTableData.value.length,
  });
  const fwbHeight = document.body.clientHeight - 420;

  /**
   * 加载数据列表
   */
  const loadTable = async () => {
    onlineTableData.value = await getOnlineList({ ...formParams });
    pager.value.count = onlineTableData.value.length;
  };

  /**
   * 注册
   */
  const [register, {}] = useForm({
    rowProps: { gutter: [16, 0] },
    colProps: {
      xs: 24,
      sm: 24,
      md: 12,
      lg: 8,
      xl: 6,
    },
    labelCol: { span: 6, offset: 0 },
    schemas,
  });

  /**
   * 执行提交表单
   * @param values 参数
   */
  function handleSubmit(values) {
    for (const key in formParams) {
      formParams[key] = '';
    }
    for (const key in values) {
      formParams[key] = values[key];
    }
    loadTable();
  }

  /**
   * 执行重置
   */
  function handleReset() {
    for (const key in formParams) {
      formParams[key] = '';
    }
    pager.value.page = 1;
    loadTable();
  }

  /**
   * 执行删除
   * @param id 参数
   */
  async function handleDelete(id) {
    Modal.confirm({
      title: '提示',
      content: '确定要强退？',
      onOk: async () => {
        await onlineOut(id);
        message.success('强退成功');
        loadTable();
      },
    });
  }

  /**
   * 钩子函数
   */
  onMounted(() => {
    loadTable();
  });
</script>

<style lang="scss" scoped></style>
